// Kernstck fr die Wahrscheinlichkeitsrechnung
// (c) 2005 Michael Stapelberg

unit Berechnungen;

interface

  uses Classes,  // Stellt TStringList/TObject bereit
       Windows,  // Stellt GetTickCount bereit
       SysUtils; // Stellt IntToStr/StrToInt bereit

  type
    PTPNumber = ^TPNumber;
    TPNumber = class(TObject)
      value:      integer;    // Wert der Zahl
      maxvalue:   integer;    // Maximalwert
      child:      PTPNumber;  // "Kind"
      topparent:  PTPNumber;  // "erster" "Vater"
      dest:       ^TStrings;  // Ziel der Ausgabe (nur beim "ersten Vater" benutzt)
      function HochZaehlen:boolean;
      procedure OutPut;
    end;

    TPrefInXofY_Result = record
      possibility:   real;    // Wahrscheinlichkeit (Hauptergebnis)
      possibilities: integer; // Mglichkeiten
      duration:      real;    // Berechnungsdauer
      fehler:        string;  // Falls ein Fehler auftrat, wird die Meldung gespeichert
    end;

  // Diese Funktionen stehen jedem Program, das die Unit "Berechnungen" einbindet, zur Verfgung
  function PrefInXofY(const pref:integer; _x,_y:integer):TPrefInXofY_Result;
  function Ueber(const oben, unten:integer):real;
  function IsNumber(const s:string): Boolean;
  procedure Possibilities(take,ins:integer; destination:TStrings);

implementation

// Die nachfolgenden Funktionen zerlegen einen String in seine Einzelteile.
function _Pos(token, source:string):integer;
var c:integer;
begin
c:=Pos(token,source);
if (c = 0) then result:=length(source) else result:=c;
end;

// Liefert den Abschnitt <number> aus <source> zurck, getrennt mittels <token>
// Beispiel: Liefert 7 bei Aufruf GetToken('5-6-7-8','-',4); zurck
function GetToken(const source, token: string; number: integer):string;
var c:integer; t:string; neg:boolean;
begin
 neg:=(number < 0);
 if (neg) then
  number:=number * -1;
 if (pos(token,source) = 0) then begin
  if (number = 1) then result:=source else result:='';
  exit;
 end;
 t:=source;
 for c:=0 to (number-2) do
  Delete(t,1,_Pos(token,t));
 if (Pos(token,t) > 0) and (not neg) then
  result:=copy(t,1,pos(token,t)-1)
 else result:=t;
end;

// siehe GetToken, liefert Anzahl der Token zurck
function NumToken(aString:string; sepchar: string):integer;
var c,num:integer; t:string;
begin
t:=aString;
num:=0;
for c:=0 to (length(t)-1) do
 if (t[c] = sepchar) then
  Inc(num);
result:=num+1;
end;

// berprft ob String <s> eine Nummer ist
function IsNumber(const s:string): Boolean;
var c:integer;
const nums:string = '0123456789';
begin
 result:=(length(s) > 0);
 for c:=1 to length(s) do
  if (Pos(copy(s,c,1),nums) = 0) then
   result:=false;
end;

// Zhlt die Zahl und alle in der Hierarchie Folgenden nach oben
function TPNumber.HochZaehlen:boolean;
var x:integer;
    curchild:PTPNumber;
begin
result:=true;
while (value < maxvalue) do begin
  x:=value;
  curchild:=child;
  while (curchild <> nil) do begin
    if (x > maxvalue) then
      exit;
    curchild.value:=x;
    curchild:=curchild.child;
    Inc(x);
  end;
  if (child <> nil) then
    TPNumber(child^).HochZaehlen;
  if (topparent <> nil) then
    TPNumber(topparent^).OutPut
  else OutPut;
  Inc(value);
end;
end;

// Speichert die Ausgabe in der Stringlist
// Diese Methode wird nur bei der ersten Nummer aufgerufen.
procedure TPNumber.Output;
var curchild:PTPNumber;
    temp:string;
// berprft, ob innerhalb einer Zahlenfolge eine Zahl doppelt vorkommt
// Hier war brigens der Fehler in der letzten Version..
function DoubleNum(input:string):boolean;
var x,y:integer;
    t,t2:string;
begin
result:=false;
t:='';
for x:=1 to NumToken(input,',') do begin
  t2:=GetToken(input,',',x);
  for y:=1 to NumToken(t,',') do
    if (GetToken(t,',',y) = t2) then begin
      result:=true;
      break;
    end;
  t:=t+','+t2;
end;
end;
begin
curchild:=child;
temp:=IntToStr(value);
while (curchild <> nil) do begin
  temp:=temp+','+IntToStr(curchild.value);
  curchild:=curchild.child;
end;
if (not DoubleNum(temp)) then
  TStrings(dest^).Add(temp);
end;

// Findet alle Mglichkeiten, <take> aus <ins> zu nehmen und speichert diese in <destination>
procedure Possibilities(take,ins:integer; destination:TStrings);
var nums:Array of TPNumber;
    x:integer;
begin
SetLength(nums,take+1);
for x:=0 to (take-1) do begin
  nums[x]:=TPNumber.Create;
  nums[x].value:=x+1;
  nums[x].maxvalue:=ins;
  nums[x].topparent:=nil;
  if (x > 0) then
    nums[x].topparent:=@nums[0]
  else nums[x].dest:=@destination;
end;

for x:=0 to (take-1) do
  if (x < (take-1)) then
    nums[x].child:=@nums[x+1]
  else nums[x].child:=nil;

if (length(nums) > 0) then
  nums[0].HochZaehlen;
end;

// Rechnet "X ber Y" aus
function Ueber(const oben, unten:integer):real;
var x:integer;
    _oben, _unten:real;
begin
  _oben:=1;
  _unten:=1;
  for x:=0 to (unten-1) do begin
    _oben:=_oben * (oben-x);
    _unten:=_unten * (unten-x);
  end;
  result:=_oben / _unten;
end;

// Probiert alle Mglichkeiten und gibt die Wahrscheinlichkeit aus, mit der
// Pref in allen Ziehungen von X aus Y vorhanden ist.
function PrefInXofY(const pref:integer; _x,_y:integer):TPrefInXofY_Result;
var all_possible:TStrings;
    x,y:         integer;
    temp:        string;
    people:      array of boolean;
    found:       boolean;
    founds:      integer;
    _start,_end: integer;
begin
_start:=GetTickCount;
all_possible:=TStringList.Create;
try
  founds:=0;

  try
    // Alle Mglichkeiten in einer Stringliste speichern
    Possibilities(_x, _y, all_possible);
  except
    result.fehler:='Fehler beim Erzeugen der Mglichkeiten';
    exit;
  end;

  result.possibilities:=all_possible.Count;

  try
    // Flle initialisieren
    SetLength(people,_y+1);
    // Standardmig alle Ereignisse auf ungnstig setzen
    for x:=0 to (length(people)-1) do
      people[x]:=false;
    for x:=0 to (pref-1) do
      people[x]:=true;
  except
    result.fehler:='Fehler beim Festlegen der gnstigen Ereignisse';
    exit;
  end;

  try
    // berprfen, wie oft <Pref> vorkam
    for x:=0 to (all_possible.Count-1) do begin
      temp:=all_possible.Strings[x];
      found:=false;
      for y:=1 to NumToken(temp,',') do
        if (not isNumber(GetToken(temp,',',y))) then begin
          result.fehler:='Eine der Mglichkeiten ergab keine ganze Zahl';
          exit;
        end else if (people[StrToInt(GetToken(temp,',',y))-1]) then begin
          found:=true;
          break;
        end;
      if (found) then
        Inc(founds);
    end;
  except
    result.fehler:='Fehler beim berprfen der Ereignisse';
    exit;
  end;

  // Division durch 0 Vorbeugen
  if (result.possibilities = 0) then
    result.possibility:=-1
  else
    try
      result.possibility:=(founds / all_possible.count);
    except
      result.fehler:='Fehler beim Berechnen der Wahrscheinlichkeit (Division durch 0?)';
      exit;
    end;
finally
  all_possible.Free;
end;
// Berechnungsdauer erzeugen
_end:=GetTickCount;
try
  result.duration:=(_end - _start) / 1000;
except
  result.fehler:='Fehler beim Erzeugen der Berechnungsdauer';
end;
end;

end.
