// (c) 2005 Michael Stapelberg
unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Berechnungen, ComCtrls, Buttons;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    StatusBar1: TStatusBar;
    sd: TSaveDialog;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    procedure Button3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Gibt <_true> zurck, wenn der Ausdruck <condition> wahr ist, ansonsten <_false>
function iifS(condition:boolean; _true,_false:string):string;
begin
if (condition) then
  result:=_true
else result:=_false;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
close;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
close;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
if (sd.Execute) then begin
  Memo1.Lines.SaveToFile(sd.FileName);
  Application.MessageBox(PAnsiChar('Ausgabe wurde erfolgreich in '+sd.FileName+' gespeichert'),'Information',MB_ICONINFORMATION+MB_OK);
end;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var math_result:TPrefInXofY_Result;
    start_here:integer;
begin
if not (isNumber(Edit1.Text) and isNumber(Edit2.Text) and isNumber(Edit3.Text)) then
  Application.MessageBox('Nicht alle eingegebenen Werte sind ganze Zahlen','Fehler',MB_ICONERROR+MB_OK)
else begin
  Memo1.Clear;
  Memo1.Lines.Add('Parameter: '+Edit1.Text+' gnstige'+iifS(Edit1.Text = '1','s','')+' Ereignis'+iifS(Edit1.Text = '1','','se'));
  Memo1.Lines.Add('Beim Ziehen von '+Edit2.Text+' aus '+Edit3.Text);
  Memo1.Lines.Add('-------------------------------------------');
  Memo1.Lines.Add('Wahrscheinlichkeit wird berechnet, bitte warten...');
  math_result:=PrefInXofY(StrToInt(Edit1.Text), StrToInt(Edit2.Text), StrToInt(Edit3.Text));
  if (length(math_result.fehler) > 0) then begin
    Memo1.Lines.Add('Es trat ein Fehler auf: '+math_result.fehler);
    StatusBar1.SimpleText:='Fehler beim Berechnen: '+math_result.fehler;
  end else begin
    Memo1.Lines.Add('-------------------------------------------');
    Memo1.Lines.Add('Mglichkeiten:        '+IntToStr(math_result.possibilities));
    start_here:=length(Memo1.Text);
    Memo1.Lines.Add('Wahrscheinlichkeit:   '+FloatToStr(math_result.possibility));
    Memo1.Lines.Add('Dauer der Berechnung: '+FloatToStr(math_result.duration)+' Sekunde'+iifS(math_result.duration = 1,'','n'));
    Memo1.SelStart:=start_here;
    Memo1.SelLength:=length(FloatToStr(math_result.possibility))+22;
    Memo1.SetFocus;
    StatusBar1.SimpleText:='Wahrscheinlichkeit wurde in '+FloatToStr(math_result.duration)+' Sekunde'+iifS(math_result.duration = 1,'','n')+' berechnet';
  end;
end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
Application.MessageBox(PAnsiChar('Wahrscheinlichkeits-Beispielprogramm'+#13#10+' 2005 Michael Stapelberg'),'Information',MB_ICONINFORMATION+MB_OK);
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
var pos:TStringList; c:integer;
begin
if not (isNumber(Edit1.Text) and isNumber(Edit2.Text) and isNumber(Edit3.Text)) then
  Application.MessageBox('Nicht alle eingegebenen Werte sind ganze Zahlen','Fehler',MB_ICONERROR+MB_OK)
else begin
  pos:=TStringList.Create;
  try
    Possibilities(StrToInt(Edit2.Text),StrToInt(Edit3.Text),pos);
    Memo1.Lines.Add('Insgesamt '+IntToStr(pos.Count)+' Ergebnis'+iifS(pos.count = 1,'','se')+' werden ausgegeben:');
    Memo1.Lines.BeginUpdate;
    for c:=0 to (pos.Count-1) do
      Memo1.Lines.Add('Ergebnis '+IntToStr(c+1)+': '+pos.Strings[c]);
    Memo1.Lines.EndUpdate;
  finally
    pos.free;
  end;
end;
end;

end.
